VERSION 5.00
Begin VB.Form CfgM401Dlg 
   BorderStyle     =   3  'Fixed Dialog
   Caption         =   "Configuration Dialog"
   ClientHeight    =   4590
   ClientLeft      =   2760
   ClientTop       =   3750
   ClientWidth     =   4245
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   4590
   ScaleWidth      =   4245
   ShowInTaskbar   =   0   'False
   Begin VB.CommandButton OKButton 
      Caption         =   "E&xit"
      Height          =   495
      Left            =   2370
      TabIndex        =   12
      Top             =   3900
      Width           =   1695
   End
   Begin VB.CommandButton DownloadBtn 
      Caption         =   "&Download"
      Height          =   495
      Left            =   240
      TabIndex        =   11
      Top             =   3930
      Width           =   1635
   End
   Begin VB.TextBox DHCP_TimeOut 
      Alignment       =   2  'Center
      Height          =   285
      Left            =   300
      TabIndex        =   8
      Top             =   3300
      Width           =   795
   End
   Begin VB.TextBox GateWay_IP 
      Height          =   555
      Left            =   2328
      TabIndex        =   5
      Text            =   "xx.xx.xx.xx"
      Top             =   2160
      Width           =   1755
   End
   Begin VB.TextBox Subnet_Mask 
      Height          =   555
      Left            =   2340
      TabIndex        =   4
      Text            =   "xx.xx.xx.xx"
      Top             =   1440
      Width           =   1755
   End
   Begin VB.TextBox MAC_Address 
      Enabled         =   0   'False
      Height          =   555
      Left            =   2352
      Locked          =   -1  'True
      TabIndex        =   3
      Text            =   "xx.xx.xx.xx"
      Top             =   120
      Width           =   1755
   End
   Begin VB.TextBox IP_Address 
      Height          =   555
      Left            =   2340
      TabIndex        =   2
      Text            =   "xx.xx.xx.xx"
      Top             =   780
      Width           =   1755
   End
   Begin VB.Frame Frame1 
      Caption         =   "DHCP timeout"
      Height          =   855
      Left            =   180
      TabIndex        =   9
      Top             =   2910
      Width           =   1395
      Begin VB.Label Label6 
         Caption         =   "Secs"
         Height          =   255
         Left            =   960
         TabIndex        =   15
         Top             =   465
         Width           =   375
      End
   End
   Begin VB.Frame Frame2 
      Caption         =   "Input Range"
      Height          =   855
      Left            =   2550
      TabIndex        =   10
      Top             =   2880
      Width           =   1515
      Begin VB.ComboBox CmbADRange 
         Height          =   315
         ItemData        =   "CfgM401.frx":0000
         Left            =   120
         List            =   "CfgM401.frx":0019
         TabIndex        =   13
         Top             =   360
         Width           =   855
      End
      Begin VB.Label Label5 
         Caption         =   "Volts"
         Height          =   255
         Left            =   1080
         TabIndex        =   14
         Top             =   480
         Width           =   375
      End
   End
   Begin VB.Label Label4 
      Caption         =   "Gateway IP"
      Height          =   435
      Left            =   180
      TabIndex        =   7
      Top             =   2280
      Width           =   1695
   End
   Begin VB.Label Label2 
      Caption         =   "Subnet Mask"
      Height          =   435
      Left            =   180
      TabIndex        =   6
      Top             =   1560
      Width           =   1695
   End
   Begin VB.Label Label3 
      Caption         =   "IP address"
      Height          =   435
      Left            =   180
      TabIndex        =   1
      Top             =   840
      Width           =   1695
   End
   Begin VB.Label Label1 
      Caption         =   "MAC Address"
      Height          =   375
      Left            =   180
      TabIndex        =   0
      Top             =   240
      Width           =   1635
   End
End
Attribute VB_Name = "CfgM401Dlg"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
'3217 Phoenixville Pike
' Malvern, PA  19355
' 800 321-5355 or 610 725-8800
' http://www.lawsonlabs.com
' March 2003
' VB demo. program for M40x A/D board,
' Uses DLL: M40x.DLL to access M401
'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''

Option Explicit


'This should be set before the dialog box is first shown, so that it can operate on the
'right device. Only one config dlg should be active any time


Private Function quadToLong(theQuad As String) As Long

Dim i As Integer
Dim d As Double
Dim v As Variant
Const conSignBit = &H80000000    '  max negative number in a long

   v = Split(theQuad, ".", 4, vbTextCompare)       '  split into array of four strings
   For i = 0 To 3
      v(i) = CInt(v(i))                            '  convert to integer
      d = d * 256 + v(i)                           '  accumulate in double
   Next i

   '  if too big for a long, make into negative number, which fits
   '  looks complex, must avoid bit masks which cause overflow in long
   
   If (d > -(conSignBit + 1)) Then d = d + conSignBit + conSignBit
   quadToLong = CLng(d)

End Function

Private Function MapADRangeToComboIndex(ByVal dblADRange As Double) As Integer
Select Case dblADRange
Case 0.045
    MapADRangeToComboIndex = 0
Case 0.1
    MapADRangeToComboIndex = 1
Case 0.2
    MapADRangeToComboIndex = 2
Case 1
    MapADRangeToComboIndex = 3
Case 2
    MapADRangeToComboIndex = 4
Case 5
    MapADRangeToComboIndex = 5
Case 7
    MapADRangeToComboIndex = 6
Case Else
    MapADRangeToComboIndex = 5 ' default 5 volts
End Select
End Function

Private Function MapComboIndexToADRangeCode(ByVal nIndex As Integer) As Byte
Select Case nIndex
Case 0
    MapComboIndexToADRangeCode = 5
Case 1
    MapComboIndexToADRangeCode = 3
Case 2
    MapComboIndexToADRangeCode = 4
Case 3
    MapComboIndexToADRangeCode = 2
Case 4
    MapComboIndexToADRangeCode = 7
Case 5
    MapComboIndexToADRangeCode = 1
Case 6
    MapComboIndexToADRangeCode = 6
Case Else
    MapComboIndexToADRangeCode = 1
End Select
End Function


Private Sub CmbADRange_Click()
Scan_obj(Selected_Index).bADRange = MapComboIndexToADRangeCode(CmbADRange.ListIndex)
End Sub

Private Sub DownloadBtn_Click()
    If vbYes <> MsgBox("You're about downloading new setting to M401" & Chr$(13) & "it may cause M401 stop working, Are you sure?", vbYesNo) Then
        Exit Sub
    End If
    'now download new settings to m401 board
    Dim dwIpAdd As Long
    Dim dwsubnet As Long
    Dim dwgateway As Long
    Dim bDHCPTmOut As Byte
    Dim subStr As Variant
    Dim dotPosition(0 To 3)  As Byte
    Dim i As Integer
    dwIpAdd = quadToLong(IP_Address.Text)
    dwsubnet = quadToLong(Subnet_Mask.Text)
    dwgateway = quadToLong(GateWay_IP.Text)
    bDHCPTmOut = DHCP_TimeOut.Text
    DLLCallRet = Pub_SetNewIPAddr(Scan_obj(Selected_Index), dwIpAdd, dwsubnet, dwgateway, bDHCPTmOut)
    If DLLCallRet = COMMAND_SUCCESS Then
        fMain.AddLogWnd ("SetNewIpAddr >> OK")
    Else
        fMain.AddLogWnd ("SetNewIpAddr >> FAILED")
    End If
    Call fMain.Connect_Click    'disconnect after download new settings
    'CfgM401Dlg.Hide                 'exit this dialog box
    Unload Me
End Sub

Private Sub Form_Load()
    'call self test to get information of M401
    Dim strSelfTst(0 To 2048) As Byte
    Dim itemStr As String
    Dim i As Integer
    Dim dblADRangeCode As Double
    DLLCallRet = Pub_GetSelfTestRst(Scan_obj(Selected_Index), strSelfTst(0))
    If DLLCallRet = COMMAND_SUCCESS Then
        i = 0
        itemStr = ""
        Do
            If strSelfTst(i) <> 10 Then
                itemStr = itemStr & Chr$(strSelfTst(i))
            Else
                If Left$(itemStr, 9) = "MAC code " Then
                    MAC_Address.Text = Mid$(itemStr, 10)
                End If
                If Left$(itemStr, 9) = "IP addr. " Then
                    IP_Address.Text = Mid$(itemStr, 10)
                End If
                If Left$(itemStr, 10) = "Net mask. " Then
                    Subnet_Mask.Text = Mid$(itemStr, 11)
                End If
                If Left$(itemStr, 12) = "Gateway IP. " Then
                    GateWay_IP.Text = Mid$(itemStr, 13)
                End If
                If Left$(itemStr, 14) = "DHCP timeout. " Then
                    DHCP_TimeOut.Text = Mid$(itemStr, 15)
                End If
                If Left$(itemStr, 16) = "A/D Full scale: " Then
                    dblADRangeCode = Val(Mid$(itemStr, 17))
                    CmbADRange.ListIndex = MapADRangeToComboIndex(dblADRangeCode)
                End If
                
                itemStr = ""
            End If
            i = i + 1
        Loop While (strSelfTst(i) <> 0)
    Else ' if Pub_GetSelfTestRst failed
        Call fMain.AddLogWnd("Self test >> FAILED -" & CodeToStr(DLLCallRet))
        Unload Me
    End If
End Sub

Private Sub GateWay_IP_LostFocus()
GateWay_IP.Text = stripIP(GateWay_IP.Text)
End Sub

Private Sub IP_Address_LostFocus()
IP_Address.Text = stripIP(IP_Address.Text)
End Sub

Private Sub OKButton_Click()
    'CfgM401Dlg.Hide     'when OK button is clicked, exit this dialog box
    Unload Me
End Sub
Private Sub Subnet_Mask_LostFocus()
Subnet_Mask.Text = stripIP(Subnet_Mask.Text)
End Sub
